diff --git a/ui/src/routes/sales/opportunity/[id]/components/CreateScheduleEntryModal.svelte b/ui/src/routes/sales/opportunity/[id]/components/CreateScheduleEntryModal.svelte
new file mode 100644
index 0000000..42678e9
--- /dev/null
+++ b/ui/src/routes/sales/opportunity/[id]/components/CreateScheduleEntryModal.svelte
@@ -0,0 +1,412 @@
+<script lang="ts">
+  import { createEventDispatcher } from "svelte";
+  import type { WorkflowActionPayload } from "$lib/optima-api/modules/sales";
+
+  const dispatch = createEventDispatcher<{
+    submit: WorkflowActionPayload;
+    close: void;
+  }>();
+
+  export let isOpen = false;
+  export let isSubmitting = false;
+  export let error: string | null = null;
+
+  type ActivityTypeValue = "Follow-Up" | "Appointment" | "Admin";
+
+  let activityTypeValue: ActivityTypeValue = "Follow-Up";
+  let startDate = "";
+  let startHour = "";
+  let endDate = "";
+  let endHour = "";
+  let notes = "";
+  let timeError = "";
+
+  function toLocalDate(d: Date): string {
+    const y = d.getFullYear();
+    const mo = String(d.getMonth() + 1).padStart(2, "0");
+    const da = String(d.getDate()).padStart(2, "0");
+    return `${y}-${mo}-${da}`;
+  }
+
+  function toLocalTime(d: Date): string {
+    const h = String(d.getHours()).padStart(2, "0");
+    const mi = String(d.getMinutes()).padStart(2, "0");
+    return `${h}:${mi}`;
+  }
+
+  function initTimes() {
+    const now = new Date();
+    const mins = now.getMinutes();
+    const roundedUp = Math.ceil(mins / 15) * 15;
+    const ended = new Date(now);
+    ended.setMinutes(roundedUp, 0, 0);
+    if (ended <= now) ended.setHours(ended.getHours() + 1);
+    const started = new Date(ended.getTime() - 60 * 60 * 1000);
+    startDate = toLocalDate(started);
+    startHour = toLocalTime(started);
+    endDate = toLocalDate(ended);
+    endHour = toLocalTime(ended);
+  }
+  initTimes();
+
+  function validate(): boolean {
+    timeError = "";
+    if (startDate && startHour && endDate && endHour) {
+      const s = new Date(`${startDate}T${startHour}`);
+      const e = new Date(`${endDate}T${endHour}`);
+      if (e <= s) {
+        timeError = "End time must be after start time.";
+        return false;
+      }
+    }
+    return true;
+  }
+
+  function handleSubmit() {
+    if (!validate()) return;
+    const startIso = startDate && startHour ? new Date(`${startDate}T${startHour}`).toISOString() : undefined;
+    const endIso   = endDate   && endHour   ? new Date(`${endDate}T${endHour}`).toISOString()     : undefined;
+    const payload: WorkflowActionPayload = {
+      activityTypeValue,
+      dueDate: endDate || undefined,
+      startTime: startIso,
+      endTime: endIso,
+      note: notes.trim() || undefined,
+    };
+    dispatch("submit", payload);
+  }
+
+  function handleClose() {
+    if (isSubmitting) return;
+    timeError = "";
+    notes = "";
+    initTimes();
+    dispatch("close");
+  }
+
+  function handleBackdropClick(e: MouseEvent) {
+    if ((e.target as HTMLElement).classList.contains("wf-modal-backdrop")) {
+      handleClose();
+    }
+  }
+
+  function handleKeydown(e: KeyboardEvent) {
+    if (e.key === "Escape") handleClose();
+  }
+</script>
+
+{#if isOpen}
+  <div
+    class="wf-modal-backdrop"
+    on:click={handleBackdropClick}
+    on:keydown={handleKeydown}
+    role="dialog"
+    aria-modal="true"
+    aria-label="Create Schedule Entry"
+    tabindex="-1"
+  >
+    <div class="wf-modal" on:click|stopPropagation>
+      <div class="wf-modal-header">
+        <h3 class="wf-modal-title">Create Schedule Entry</h3>
+        <button
+          class="wf-modal-close"
+          on:click={handleClose}
+          disabled={isSubmitting}
+          aria-label="Close"
+        >
+          <svg viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" width="16" height="16">
+            <line x1="18" y1="6" x2="6" y2="18" /><line x1="6" y1="6" x2="18" y2="18" />
+          </svg>
+        </button>
+      </div>
+
+      <div class="wf-modal-body">
+        {#if error}
+          <div class="wf-inline-error">
+            <svg viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" width="14" height="14">
+              <circle cx="12" cy="12" r="10" /><line x1="12" y1="8" x2="12" y2="12" /><line x1="12" y1="16" x2="12.01" y2="16" />
+            </svg>
+            {error}
+          </div>
+        {/if}
+
+        <!-- Activity Type pills -->
+        <div class="se-form-group se-full-width">
+          <label class="se-label">Activity Type <span class="se-req">*</span></label>
+          <div class="se-type-pills">
+            {#each (["Follow-Up", "Appointment", "Admin"] as const) as t}
+              <button
+                type="button"
+                class="se-pill"
+                class:se-pill-active={activityTypeValue === t}
+                on:click={() => (activityTypeValue = t)}
+                disabled={isSubmitting}
+              >
+                {#if t === "Follow-Up"}
+                  <svg viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" width="13" height="13">
+                    <path d="M22 16.92v3a2 2 0 01-2.18 2 19.79 19.79 0 01-8.63-3.07 19.5 19.5 0 01-6-6 19.79 19.79 0 01-3.07-8.67A2 2 0 014.11 2h3a2 2 0 012 1.72c.127.96.361 1.903.7 2.81a2 2 0 01-.45 2.11L8.09 9.91a16 16 0 006 6l1.27-1.27a2 2 0 012.11-.45c.908.339 1.85.573 2.81.7A2 2 0 0122 16.92z"/>
+                  </svg>
+                {:else if t === "Appointment"}
+                  <svg viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" width="13" height="13">
+                    <rect x="3" y="4" width="18" height="18" rx="2" ry="2"/>
+                    <line x1="16" y1="2" x2="16" y2="6"/><line x1="8" y1="2" x2="8" y2="6"/><line x1="3" y1="10" x2="21" y2="10"/>
+                  </svg>
+                {:else}
+                  <svg viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" width="13" height="13">
+                    <circle cx="12" cy="12" r="10"/><polyline points="12 6 12 12 16 14"/>
+                  </svg>
+                {/if}
+                {t}
+              </button>
+            {/each}
+          </div>
+        </div>
+
+        <!-- Date/time grid -->
+        <div class="se-grid">
+          <div class="se-form-group">
+            <label class="se-label" for="se-start-date">Start Date</label>
+            <input
+              id="se-start-date"
+              type="date"
+              class="se-input"
+              class:se-input-error={!!timeError}
+              bind:value={startDate}
+              disabled={isSubmitting}
+              on:change={() => (timeError = "")}
+            />
+          </div>
+          <div class="se-form-group">
+            <label class="se-label" for="se-start-time">Start Time</label>
+            <input
+              id="se-start-time"
+              type="time"
+              class="se-input"
+              class:se-input-error={!!timeError}
+              bind:value={startHour}
+              disabled={isSubmitting}
+              on:change={() => (timeError = "")}
+            />
+          </div>
+          <div class="se-form-group">
+            <label class="se-label" for="se-end-date">End Date</label>
+            <input
+              id="se-end-date"
+              type="date"
+              class="se-input"
+              class:se-input-error={!!timeError}
+              bind:value={endDate}
+              disabled={isSubmitting}
+              on:change={() => (timeError = "")}
+            />
+          </div>
+          <div class="se-form-group">
+            <label class="se-label" for="se-end-time">End Time</label>
+            <input
+              id="se-end-time"
+              type="time"
+              class="se-input"
+              class:se-input-error={!!timeError}
+              bind:value={endHour}
+              disabled={isSubmitting}
+              on:change={() => (timeError = "")}
+            />
+          </div>
+        </div>
+        {#if timeError}
+          <span class="se-field-error">{timeError}</span>
+        {/if}
+
+        <!-- Notes -->
+        <div class="se-form-group se-full-width">
+          <label class="se-label" for="se-notes">Notes <span class="se-optional">(optional)</span></label>
+          <textarea
+            id="se-notes"
+            class="se-textarea"
+            rows={3}
+            placeholder="Add any notes for this schedule entry…"
+            bind:value={notes}
+            disabled={isSubmitting}
+          ></textarea>
+        </div>
+      </div>
+
+      <div class="wf-modal-footer">
+        <button class="wf-action-btn wf-btn-ghost" on:click={handleClose} disabled={isSubmitting}>
+          Cancel
+        </button>
+        <button
+          class="wf-action-btn wf-btn-primary"
+          on:click={handleSubmit}
+          disabled={isSubmitting}
+        >
+          {#if isSubmitting}
+            <span class="wf-spinner"></span> Creating…
+          {:else}
+            Create Entry
+          {/if}
+        </button>
+      </div>
+    </div>
+  </div>
+{/if}
+
+<style>
+  /* ── Layout ── */
+  .se-grid {
+    display: grid;
+    grid-template-columns: 1fr 1fr;
+    gap: 12px;
+    margin-bottom: 14px;
+  }
+
+  .se-form-group {
+    display: flex;
+    flex-direction: column;
+    gap: 5px;
+    margin-bottom: 14px;
+  }
+
+  .se-full-width {
+    grid-column: 1 / -1;
+  }
+
+  /* ── Label ── */
+  .se-label {
+    font-size: 12px;
+    font-weight: 600;
+    color: var(--text-muted, #888);
+    text-transform: uppercase;
+    letter-spacing: 0.05em;
+  }
+
+  .se-req {
+    color: #ef4444;
+    font-weight: 700;
+  }
+
+  .se-optional {
+    font-weight: 400;
+    text-transform: none;
+    letter-spacing: 0;
+    font-size: 11px;
+  }
+
+  /* ── Inputs ── */
+  .se-input {
+    width: 100%;
+    padding: 8px 12px;
+    border: 1px solid var(--border-subtle, #ddd);
+    border-radius: 8px;
+    background: var(--bg-inset, #fafafa);
+    font-size: 13px;
+    color: var(--text-primary, #1a1a1a);
+    box-sizing: border-box;
+    font-family: inherit;
+    transition: border-color 0.15s, box-shadow 0.15s, background 0.15s;
+  }
+
+  .se-input:focus {
+    outline: none;
+    border-color: #3b82f6;
+    box-shadow: 0 0 0 3px rgba(59, 130, 246, 0.12);
+    background: var(--bg-surface, #fff);
+  }
+
+  .se-input:disabled {
+    opacity: 0.5;
+    cursor: not-allowed;
+  }
+
+  .se-input-error {
+    border-color: #ef4444 !important;
+  }
+
+  .se-field-error {
+    font-size: 11.5px;
+    color: #ef4444;
+    margin-top: -8px;
+    margin-bottom: 8px;
+    display: block;
+  }
+
+  /* ── Type pills ── */
+  .se-type-pills {
+    display: flex;
+    gap: 8px;
+    flex-wrap: wrap;
+  }
+
+  .se-pill {
+    display: inline-flex;
+    align-items: center;
+    gap: 5px;
+    padding: 6px 14px;
+    border-radius: 20px;
+    border: 1px solid var(--border-subtle, #ddd);
+    background: transparent;
+    color: var(--text-muted, #888);
+    font-size: 13px;
+    font-family: inherit;
+    cursor: pointer;
+    transition: border-color 0.15s, color 0.15s, background 0.15s;
+  }
+
+  .se-pill:hover:not(:disabled) {
+    border-color: #3b82f6;
+    color: #3b82f6;
+  }
+
+  .se-pill.se-pill-active {
+    border-color: #3b82f6;
+    background: rgba(59, 130, 246, 0.08);
+    color: #3b82f6;
+    font-weight: 600;
+  }
+
+  .se-pill:disabled {
+    opacity: 0.5;
+    cursor: not-allowed;
+  }
+
+  /* ── Textarea ── */
+  .se-textarea {
+    width: 100%;
+    padding: 10px 12px;
+    border: 1px solid var(--border-subtle, #ddd);
+    border-radius: 8px;
+    background: var(--bg-inset, #fafafa);
+    font-size: 13px;
+    color: var(--text-primary, #1a1a1a);
+    box-sizing: border-box;
+    resize: vertical;
+    font-family: inherit;
+    line-height: 1.5;
+    transition: border-color 0.15s, box-shadow 0.15s;
+  }
+
+  .se-textarea:focus {
+    outline: none;
+    border-color: #3b82f6;
+    box-shadow: 0 0 0 3px rgba(59, 130, 246, 0.12);
+    background: var(--bg-surface, #fff);
+  }
+
+  .se-textarea::placeholder {
+    color: var(--text-muted, #aaa);
+  }
+
+  .se-textarea:disabled {
+    opacity: 0.5;
+    cursor: not-allowed;
+  }
+
+  /* ── Footer ── */
+  .wf-modal-footer {
+    display: flex;
+    justify-content: flex-end;
+    gap: 0.5rem;
+    padding: 0.75rem 1rem;
+    border-top: 1px solid var(--border-color, #333);
+  }
+</style>
diff --git a/ui/src/routes/sales/opportunity/[id]/components/WorkflowPanel.svelte b/ui/src/routes/sales/opportunity/[id]/components/WorkflowPanel.svelte
index b70b087..21f773d 100644
--- a/ui/src/routes/sales/opportunity/[id]/components/WorkflowPanel.svelte
+++ b/ui/src/routes/sales/opportunity/[id]/components/WorkflowPanel.svelte
@@ -15,6 +15,7 @@
     TERMINAL_STATUSES,
     REOPENABLE_STATUSES,
     QUOTE_CONFIRMED_STATUSES,
+    ADD_TIME_EXCLUDED_STATUSES,
   } from "$lib/optima-api/modules/sales";
   import type { PermissionMap } from "$lib/permissions";
   import type {
@@ -25,6 +26,9 @@
   import SendQuoteModal from "./SendQuoteModal.svelte";
   import ReviewDecisionModal from "./ReviewDecisionModal.svelte";
   import FinalizeModal from "./FinalizeModal.svelte";
+  import AddTimeModal from "./AddTimeModal.svelte";
+  import CreateScheduleEntryModal from "./CreateScheduleEntryModal.svelte";
+  import { formatDateTime } from "../types";
 
   const dispatch = createEventDispatcher<{
     workflowChanged: { result: WorkflowResult; freshWorkflowStatus: WorkflowStatusResponse | null };
@@ -44,6 +48,16 @@
   let isSubmitting = false;
   let preselectedOutcome: "won" | "lost" | null = null;
 
+  // Add Time modal state
+  let showAddTimeModal = false;
+  let addTimeActivities: Array<{ cwActivityId: number; name: string; optimaType: string | null }> = [];
+  let isLoadingActivities = false;
+
+  // Create Schedule Entry modal state
+  let showScheduleEntryModal = false;
+  let scheduleEntryError: string | null = null;
+  let isScheduleEntrySubmitting = false;
+
   // Derived state
   $: statusKey = workflowStatus
     ? (STATUS_ID_TO_KEY[workflowStatus.currentStatusId] ?? null)
@@ -76,6 +90,21 @@
   $: canReopen = permissions["sales.opportunity.reopen"] !== false;
   $: hasQuotes = quotes.length > 0;
 
+  /** "Add Time" is available on all statuses except terminal/pending-outcome/canceled */
+  $: canShowAddTime = statusKey
+    ? !ADD_TIME_EXCLUDED_STATUSES.has(statusKey) && isOptimaStage
+    : false;
+
+  /** Open (unclosed) schedule entries for this opportunity */
+  $: openScheduleEntries = activities
+    .filter((a) => {
+      const optimaType = a.customFields?.find(
+        (f) => f.caption === "Optima_Type" || f.id === 45,
+      )?.value;
+      return optimaType === "Schedule Entry" && a.status?.id !== 2;
+    })
+    .sort((a, b) => (a.dateStart ?? "").localeCompare(b.dateStart ?? ""));
+
   /** For resendQuote: check that a quote was generated after the last revision opening */
   $: hasQuoteSinceRevision = (() => {
     if (!hasQuotes) return false;
@@ -209,6 +238,8 @@
       cancel: "Cancel",
       reopen: "Reopen",
       acceptNew: "Accept",
+      sendBackForRevision: "Send Back for Revision",
+      createScheduleEntry: "Create Schedule Entry",
     };
     return overrides[action.action] ?? action.label;
   }
@@ -299,6 +330,72 @@
     activeModal = e.detail.action;
   }
 
+  /** Open the Add Time modal */
+  function openAddTimeModal() {
+    showAddTimeModal = true;
+  }
+
+  /** Handle successful time submission from AddTimeModal */
+  function handleAddTimeSuccess() {
+    showAddTimeModal = false;
+    dispatch("workflowChanged", {
+      result: {
+        success: true,
+        previousStatusId: workflowStatus?.currentStatusId ?? null,
+        newStatusId: workflowStatus?.currentStatusId ?? null,
+        previousStatus: null,
+        newStatus: null,
+        activitiesCreated: [],
+        coldCheck: null,
+        error: null,
+      },
+      freshWorkflowStatus: null,
+    });
+  }
+
+  /** Submit a Create Schedule Entry action */
+  async function submitScheduleEntry(payload: WorkflowActionPayload) {
+    isScheduleEntrySubmitting = true;
+    scheduleEntryError = null;
+    try {
+      const json = await clientFetch<{
+        successful: boolean;
+        message?: string;
+        data?: { error?: string };
+      }>(`/sales/opportunity/${opportunityId}/workflow`, {
+        method: "POST",
+        headers: { "Content-Type": "application/json" },
+        body: JSON.stringify({ action: "createScheduleEntry", payload }),
+      });
+
+      if (json.successful === false) {
+        scheduleEntryError = json.message ?? json.data?.error ?? "Failed to create schedule entry.";
+        return;
+      }
+
+      showScheduleEntryModal = false;
+      const result = json.data as WorkflowResult;
+      if (result?.activitiesCreated?.length) {
+        activities = [...result.activitiesCreated, ...activities];
+      }
+
+      // Fetch fresh workflow status
+      let freshWorkflowStatus: WorkflowStatusResponse | null = null;
+      try {
+        const statusJson = await clientFetch<{ data: WorkflowStatusResponse }>(
+          `/sales/opportunity/${opportunityId}/workflow`,
+        );
+        freshWorkflowStatus = statusJson.data ?? null;
+      } catch { /* ignore */ }
+
+      dispatch("workflowChanged", { result: result ?? { success: true, previousStatusId: null, newStatusId: null, previousStatus: null, newStatus: null, activitiesCreated: [], coldCheck: null, error: null }, freshWorkflowStatus });
+    } catch (err) {
+      scheduleEntryError = err instanceof Error ? err.message : "Failed to create schedule entry.";
+    } finally {
+      isScheduleEntrySubmitting = false;
+    }
+  }
+
   /** Determine if action needs a special modal */
   function isSpecialModal(action: WorkflowAction): boolean {
     return ["sendQuote", "resendQuote", "reviewDecision", "finalize"].includes(
@@ -494,6 +591,68 @@
             </button>
           {/if}
         {/if}
+
+        <!-- Add Time + Create Schedule Entry buttons (right side) -->
+        {#if canShowAddTime || true}
+          <span class="wf-action-sep" aria-hidden="true"></span>
+          <!-- Create Schedule Entry (calendar icon) -->
+          <span class="wf-tooltip-wrap" data-tooltip="Create Schedule Entry">
+            <button
+              class="wf-action-btn wf-btn-icon"
+              on:click={() => { showScheduleEntryModal = true; scheduleEntryError = null; }}
+              disabled={isSubmitting || isScheduleEntrySubmitting}
+              aria-label="Create Schedule Entry"
+            >
+              <svg viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" width="15" height="15">
+                <rect x="3" y="4" width="18" height="18" rx="2" ry="2" />
+                <line x1="16" y1="2" x2="16" y2="6" />
+                <line x1="8" y1="2" x2="8" y2="6" />
+                <line x1="3" y1="10" x2="21" y2="10" />
+              </svg>
+            </button>
+          </span>
+          <!-- Add Time (clock icon) -->
+          {#if canShowAddTime}
+            <span class="wf-tooltip-wrap" data-tooltip="Add Time">
+              <button
+                class="wf-action-btn wf-btn-icon"
+                on:click={openAddTimeModal}
+                disabled={isSubmitting || isLoadingActivities}
+                aria-label="Add Time"
+              >
+                {#if isLoadingActivities}
+                  <span class="wf-spinner wf-spinner-sm"></span>
+                {:else}
+                  <svg viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" width="15" height="15">
+                    <circle cx="12" cy="12" r="10" /><polyline points="12 6 12 12 16 14" />
+                  </svg>
+                {/if}
+              </button>
+            </span>
+          {/if}
+        {/if}
+      </div>
+    {/if}
+
+    <!-- Pending schedule entries -->
+    {#if openScheduleEntries.length > 0}
+      <div class="wf-schedule-entries">
+        {#each openScheduleEntries as entry}
+          <div class="wf-se-item">
+            <svg viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" width="12" height="12" class="wf-se-icon">
+              <rect x="3" y="4" width="18" height="18" rx="2" ry="2" />
+              <line x1="16" y1="2" x2="16" y2="6" />
+              <line x1="8" y1="2" x2="8" y2="6" />
+              <line x1="3" y1="10" x2="21" y2="10" />
+            </svg>
+            <span class="wf-se-name">{entry.name ?? "Schedule Entry"}</span>
+            {#if entry.dateStart}
+              <span class="wf-se-time">
+                {formatDateTime(entry.dateStart)}{#if entry.dateEnd}&nbsp;–&nbsp;{formatDateTime(entry.dateEnd)}{/if}
+              </span>
+            {/if}
+          </div>
+        {/each}
       </div>
     {/if}
 
@@ -586,3 +745,21 @@
     on:close={closeModal}
   />
 {/if}
+
+<!-- Add Time modal -->
+<AddTimeModal
+  isOpen={showAddTimeModal}
+  {opportunityId}
+  on:success={handleAddTimeSuccess}
+  on:close={() => { showAddTimeModal = false; }}
+  on:createScheduleEntry={() => { showAddTimeModal = false; showScheduleEntryModal = true; }}
+/>
+
+<!-- Create Schedule Entry modal -->
+<CreateScheduleEntryModal
+  isOpen={showScheduleEntryModal}
+  isSubmitting={isScheduleEntrySubmitting}
+  error={scheduleEntryError}
+  on:submit={(e) => submitScheduleEntry(e.detail)}
+  on:close={() => { showScheduleEntryModal = false; scheduleEntryError = null; }}
+/>
diff --git a/ui/src/routes/sales/opportunity/[id]/time/+server.ts b/ui/src/routes/sales/opportunity/[id]/time/+server.ts
new file mode 100644
index 0000000..7b14729
--- /dev/null
+++ b/ui/src/routes/sales/opportunity/[id]/time/+server.ts
@@ -0,0 +1,32 @@
+import { optima } from "$lib";
+import { json, error } from "@sveltejs/kit";
+import type { RequestHandler } from "./$types";
+
+/** POST /sales/opportunity/[id]/time — log time against an activity */
+export const POST: RequestHandler = async ({ params, request, locals }) => {
+  const accessToken = locals.session?.accessToken;
+  if (!accessToken) throw error(401, "Unauthorized");
+
+  const body = await request.json();
+
+  try {
+    const result = await optima.sales.addTimeToActivity(
+      accessToken,
+      params.id,
+      body,
+    );
+    return json(result);
+  } catch (err: unknown) {
+    console.error("[Time] Failed to log time:", err);
+    const status =
+      err && typeof err === "object" && "status" in err
+        ? (err as { status: number }).status
+        : 500;
+    const message =
+      err && typeof err === "object" && "response" in err
+        ? ((err as { response?: { data?: { message?: string } } }).response
+            ?.data?.message ?? "Failed to log time")
+        : "Failed to log time";
+    throw error(status, message);
+  }
+};
